"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const feathers_utils_1 = require("feathers-utils");
const authorize_hook_utils_1 = require("./authorize.hook.utils");
const authorize_hook_after_1 = __importDefault(require("./authorize.hook.after"));
const authorize_hook_before_1 = __importDefault(require("./authorize.hook.before"));
const HOOKNAME = "authorize";
exports.default = (options) => {
    return (context) => __awaiter(void 0, void 0, void 0, function* () {
        if (feathers_utils_1.shouldSkip(HOOKNAME, context) ||
            !context.params ||
            context.type === "error") {
            return context;
        }
        const fullOptions = authorize_hook_utils_1.makeOptions(context.app, options);
        return (context.type === "before")
            ? yield authorize_hook_before_1.default(fullOptions)(context)
            : yield authorize_hook_after_1.default(fullOptions)(context);
    });
};
