"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const feathers_utils_1 = require("feathers-utils");
const getFieldsQueryFor_1 = __importDefault(require("./getFieldsQueryFor"));
const getConditionalQueryFor_1 = __importDefault(require("./getConditionalQueryFor"));
const getQueryFor = (ability, method, modelName, options) => {
    options = options || {
        availableFields: []
    };
    const { skipConditional, skipFields } = options;
    if (skipConditional && skipFields) {
        return {};
    }
    const conditionsQuery = (!skipConditional)
        ? getConditionalQueryFor_1.default(ability, method, modelName, { actionOnForbidden: options.actionOnForbidden })
        : {};
    const fieldsQuery = (!skipFields)
        ? getFieldsQueryFor_1.default(ability, method, modelName, { availableFields: options.availableFields })
        : {};
    const query = feathers_utils_1.mergeQuery(conditionsQuery, fieldsQuery, { defaultHandle: "combine" });
    return query;
};
exports.default = getQueryFor;
